# The following defines the version of compiler we are doing this for so 
# that we can do this easily as new versions come out, directly when
# rebuilding this src.rpm
%{!?intelversion:%define intelversion 11.1.075}

# The rest should be figured out automatically just from the above two things
%define intelshortversion %(echo %{intelversion} | cut -d. -f1-2)
%define intelshortshortversion %(echo %{intelversion} | cut -d. -f1)
%define intelrelease %(echo %{intelversion} | cut -d. -f3)
%define intelnumversion %(echo %{intelversion} | tr -d \.)

# Our root dir is now always:
%define intelinstalldir /opt/intel/Compiler/%{intelshortversion}/%{intelrelease}

# here for different bits
%ifarch i486 i686
%define intelbits 32
%define extrabit %{nil}
%define archdir ia32
%define mklarchdir 32
%else
%ifarch ia64
%define intelbits 64
%define archdir ia64
%define mklarchdir 64
%define extrabit %{nil}
%else
%define intelbits 64
%define extrabit e
%define archdir intel64
%define mklarchdir em64t
%endif
%endif

# The destination location for modules files
%define modulesdestination /opt/share/Modules/modulefiles

Summary: Modules configuration files for intel %{intelnumversion} %{intelversion} pro compiler
Name: intel-cpro%{intelnumversion}-modules
Version: %{intelversion}
Release: 12%{?dist}
License: Other
Group: Development/Languages
ExclusiveArch: i486 x86_64 ia64 i686
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Provides: intel-cpro111-modules = %{intelversion}
Provides: intel-cpro11-modules = %{intelversion}
Provides: intel-cpro-modules = %{intelversion}
Provides: intel-compiler-default-modules = %{intelshortversion}-%{intelrelease}
Provides: intel-compiler%{intelshortshortversion}-%{intelbits}-default-modules = %{intelshortversion}-%{intelrelease}
Provides: intel-compiler-%{intelbits}-default-modules = %{intelshortversion}-%{intelrelease}
Requires: environment-modules >= 3.2.3
Requires: intel-license
Requires: hardlink
Requires: compat-libstdc++-33
# fixing a missing provide by the core rpms
%if "%{intelbits}" == "64"
Provides: libintlc.so.5()(64bit)
Provides: libiomp5.so()(64bit)
Provides: libiomp5.so(VERSION)(64bit)
%else
Provides: libintlc.so.5
Provides: libiomp5.so
Provides: libiomp5.so(VERSION)
%endif
Obsoletes: intel-cproc110074%{extrabit}
Obsoletes: intel-cprof110074%{extrabit}
Obsoletes: intel-cproc110074iidb%{extrabit}
Obsoletes: intel-cproc110081%{extrabit}
Obsoletes: intel-cprof110081%{extrabit}
Obsoletes: intel-cproc110081iidb%{extrabit}
Obsoletes: intel-cproc110083%{extrabit}
Obsoletes: intel-cprof110083%{extrabit}
Obsoletes: intel-cproc110083iidb%{extrabit}
Obsoletes: intel-cpro110074-modules
Obsoletes: intel-cpro110081-modules
Obsoletes: intel-cpro110083-modules
Requires: intel-cproflib%{intelrelease} = %{intelshortversion}
Requires: intel-cprolib%{intelrelease} = %{intelshortversion}
Requires: intel-cpromklib%{intelrelease} = %{intelshortversion}

%description
This rpm contains modules configuration files for the Intel pro
compiler version %{intelversion}

It also fixes up various scripts like icc, ifc, icvars and other Intel 
scripts where they reference INSTALLDIR (in original Intel's RPM).

%package devel
Group: Development/Languages
Summary: Configuration files for intel %{intelnumversion} %{intelversion} pro compiler - development
Requires: intel-cpro%{intelnumversion}-modules = %{intelversion}-%{release}
Requires: intel-cproc%{intelrelease} = %{intelshortversion}
Requires: intel-cprocsdk%{intelrelease} = %{intelshortversion}
Requires: intel-cprof%{intelrelease} = %{intelshortversion}
Requires: intel-cprofsdk%{intelrelease} = %{intelshortversion}
Requires: intel-cproidb%{intelrelease} = %{intelshortversion}
Requires: intel-cproidbcdt%{intelrelease} = %{intelshortversion}
Requires: intel-cproidbsdk%{intelrelease} = %{intelshortversion}
Requires: intel-cprolibdev%{intelrelease} = %{intelshortversion}
Requires: intel-cpromklibdev%{intelrelease} = %{intelshortversion}
Provides: intel-cpro111-modules-deve = %{intelversion}
Provides: intel-cpro11-modules-devel = %{intelversion}
Provides: intel-cpro-modules-devel = %{intelversion}
Provides: intel-compiler-default-modules-devel = %{intelshortversion}-%{intelrelease}
Provides: intel-compiler%{intelshortshortversion}-%{intelbits}-default-modules-devel = %{intelshortversion}-%{intelrelease}
Provides: intel-compiler-%{intelbits}-default-modules-devel = %{intelshortversion}-%{intelrelease}

%description devel
This rpm just contains relevant development requirements.


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{modulesdestination}/intel/%{intelshortversion}/%{intelbits}
mkdir -p $RPM_BUILD_ROOT/usr/local/intel/{bin,include,%{_lib}}
cat > $RPM_BUILD_ROOT%{modulesdestination}/intel/%{intelshortversion}/%{intelbits}/%{intelversion} <<ENDDEFAULT
#%Module1.0#####################################################################
##
## %{intelversion} %{intelbits} modulefile
##
proc ModulesHelp { } {
        global version

        puts stderr "\tThis module sets appropriate paths for using Intel Pro compiler %{intelversion} %{intelbits}bit"
        puts stderr "\t"
        puts stderr "\n\tVersion \$version\n"
}

module-whatis   "Loads settings for the Intel %{intelversion} %{intelbits} bit"
prepend-path	PATH		%{intelinstalldir}/bin/%{archdir}:/usr/local/intel/bin
prepend-path	MANPATH		%{intelinstalldir}/man/en_US:%{intelinstalldir}/mkl/man/en_US
prepend-path	LD_LIBRARY_PATH	%{intelinstalldir}/lib/%{archdir}:%{intelinstalldir}/mkl/lib/%{mklarchdir}:/usr/local/intel/%{_lib}
prepend-path	NLSPATH		%{intelinstalldir}/lib/%{archdir}/locale/%l_%t/%N:%{intelinstalldir}/mkl/lib/%{mklarchdir}/locale/%l_%t/%N:%%{intelinstalldir}/idb/%{archdir}/locale/%l_%t/%N
prepend-path	INCLUDE		/usr/local/intel/include:%{intelinstalldir}/mkl/include
prepend-path	CPATH		/usr/local/intel/include:%{intelinstalldir}/mkl/include
prepend-path	FPATH		/usr/local/intel/include:%{intelinstalldir}/mkl/include
prepend-path	LIBRARY_PATH	/usr/local/intel/%{_lib}:%{intelinstalldir}/lib/%{archdir}:%{intelinstalldir}/mkl/lib/%{mklarchdir}
append-path -delim { } LOCAL_LDFLAGS "-L/usr/local/intel/%{_lib} -L%{intelinstalldir}/lib/%{archdir} -L%{intelinstalldir}/mkl/lib/%{mklarchdir}"
append-path -delim { } LOCAL_CFLAGS "-I/usr/local/intel/include -I%{intelinstalldir}/mkl/include"
append-path -delim { } LOCAL_CXXFLAGS "-I/usr/local/intel/include -I%{intelinstalldir}/mkl/include"
append-path -delim { } LOCAL_FFLAGS "-I/usr/local/intel/include -I%{intelinstalldir}/mkl/include"
set     version      "3.2.3"
ENDDEFAULT

cat > $RPM_BUILD_ROOT%{modulesdestination}/intel/.modulerc-intel-%{intelnumversion}-%{intelbits} <<ENDGENERIC
#%Module
module-alias intel/%{intelshortshortversion} intel/%{intelshortversion}
ENDGENERIC
mkdir $RPM_BUILD_ROOT%{modulesdestination}/intel/%{intelshortshortversion}
cat > $RPM_BUILD_ROOT%{modulesdestination}/intel/%{intelshortshortversion}/.modulerc-intel-%{intelnumversion}-%{intelbits} <<ENDMOREGENERIC
#%Module
module-alias intel/%{intelshortshortversion}/%{intelbits} intel/%{intelshortversion}/%{intelbits}
ENDMOREGENERIC

%post
/usr/sbin/hardlink -c %{intelinstalldir} /opt/intel >/dev/null 2>&1 || :

%post devel
/usr/sbin/hardlink -c %{intelinstalldir} /opt/intel >/dev/null 2>&1 || :

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%dir %{modulesdestination}/intel
%dir %{modulesdestination}/intel/%{intelshortversion}
%dir %{modulesdestination}/intel/%{intelshortversion}/%{intelbits}
%{modulesdestination}/intel/%{intelshortversion}/%{intelbits}/*
%{modulesdestination}/intel/.modulerc-intel-%{intelnumversion}-%{intelbits}
%dir %{modulesdestination}/intel/%{intelshortshortversion}
%{modulesdestination}/intel/%{intelshortshortversion}/.modulerc-intel-%{intelnumversion}-%{intelbits}
%dir /usr/local/intel/bin
%dir /usr/local/intel/%{_lib}

%files devel
%defattr(-,root,root)
%dir /usr/local/intel/include

%changelog
* Thu Dec 03 2009 Josko Plazonic <plazonic@math.princeton.edu>
- added /usr/local/intel/bin to the path and the appropriate dirs to rpm 
  ownership (to ensure existence)
- updated to 11.1.059
